import java.applet.Applet;
import java.awt.BorderLayout;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.geometry.ColorCube;
import com.sun.j3d.utils.universe.*;

public class Hello3D extends Applet
{
	private Canvas3D canvas;
	private SimpleUniverse universe;

	public void init()
	{
		canvas=new Canvas3D(null);
		universe=new SimpleUniverse(canvas);
		
		universe.getViewingPlatform().setNominalViewingTransform();
		// _KȈʒuɐݒ
		universe.addBranchGraph(createSceneGraph());
		
		setLayout(new BorderLayout());
		add(canvas,BorderLayout.CENTER);
	}

	private BranchGroup createSceneGraph()		// SceneGraph ̍\z
	{
		BranchGroup root;
		Transform3D rotation,rotationX,rotationY;
		TransformGroup transform;
	
		root=new BranchGroup();
		
		rotationX=new Transform3D();
		rotationX.rotX(Math.PI/4.0);		// c /4 ]
		
		rotationY=new Transform3D();
		rotationY.rotY(Math.PI/5.0);		//  /5 ]
		
		rotation=new Transform3D();
		rotation.mul(rotationX,rotationY);	// 2̉]
		
		transform=new TransformGroup(rotation);
		root.addChild(transform);
		
		transform.addChild(new ColorCube(0.4));
		// 傫 0.4 ̐Ft
		
		return root;
	}
}
